%% DT_T4_d2.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #4
% Demo 2
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Dynaaminen ryhmittely: c-means algoritmi
%
% Paperilaskarien tehtv H4 / 2
%  ratkaistaankin nyt c-means-ryhmittelyalgoritmilla.

%% Kokeilu:
% 
% - muokkaa klusterien lukumr c "lkmK" rivill 61
% - aja monta kertaa samalla datalla: eri alkuarvot
%    tuottavat eri tuloksen
% - voit muokata dataa X rivill 28-29

%% Datapisteet
%
% Data on esitetty kurssilla esitetyll tavalla:
%  muuttujat rivein ja havainnot sarakkeina. 
%  Matlab tulkitsee datamatriisin juuri toisinpin
%  ja siksi X tullaan transponoimaan muuttujaksi D Matlabin
%  ryhmittelyfunktiolle.

X = [0  1  2.5  3   3  5; 
    0   1  2.5  2   4  3];
D = X';  % Matlabin omia laskurutiineja varten matriisi "toisin pin"

%% Piirretn

figure(421); clf;
plot(X(1,:), X(2,:), 'x');
grid on;
title(['Datapisteet n = ' num2str(size(X,2))]);
axis equal;
aXlim = get(gca,'XLim');
aYlim = get(gca,'YLim');
aXlim = aXlim + (aXlim(2)-aXlim(1))*[-.1 .1];
aYlim = aYlim + (aYlim(2)-aYlim(1))*[-.1 .1];
axis([aXlim aYlim]);

for k = 1 : size(X, 2)
    text(X(1,k)+0.2, X(2,k)-0.1, num2str(k));
end;

% Seuraavaa tarvitaan ryppit eroteltaessa
vm = {'bo','kx','r+','c*','ms','gd','bv','g^','r<','c>','mp','kh','b+','g*','rs','cd','mo','kx','bs','gd','ro','cx','ms','kd'};

%% Dynaaminen ryhmittely: c-means algoritmi
%
% Funktio 'kmeans' palauttaa indeksijonon cl_ind, jossa
%  on datapisteiden mr indeksej i liittyen kuhunkin
%  ryhmn C_i, i = 1..lkmK, jossa lkmK ryhmien lukumr.
% Se palauttaa mys matriisin 'kkpiste', jossa on 
%  lkmK rivi vastaten kunkin klusterin keskipistevektoria.

% VOIT MUUTTAA lkmK
lkmK  = 3;               % mr klusterien lukumrn
[cl_ind, kkpiste] = kmeans(D, lkmK, 'display', 'iter');  % C-MEANS!!!

% HUOM! Tm algoritmi ptyy lokaaliin minimiin ja
%  on herkk aloituspisteiden valinnalle.
%  Siksi algoritmia kannattaa ajaa useita kertoja.
% Samoin klusterien "oikeaa" mr voi arvioida,
%  kuinka hyvin samaan klusteriin kuuluvat pisteet ovat 
%  samanlaisia ja kuinka erilaisia eri klustereihin kuuluvat
%  pisteet ovat. 
% Jos haluat tutustua nihin aiheeseen, katso 'doc' ja
%  valitse 'Statistics Toolbox' -> 'Cluster Analysis' ->
%  'K-Means Clustering'.

%% Piirretn c-means ryhmittelyn tulokset
%
% Piirretn klusterit eri vreill/merkeill

figure(422); clf;
for k = 1 : lkmK
    ind = find(cl_ind == k);
    plot(X(1,ind), X(2, ind), vm{k});
    hold on;
end;
grid on;
title(['Data jaettuna ' num2str(lkmK) ' ryhmn']);
axis equal; 
axis([aXlim aYlim]);

% Listn 'legend'
for k = 1 : lkmK
    legTitle{k} = ['Klusteri #' num2str(k)];
end;
legend(legTitle, 'Location', 'SouthEast');

% Listn datapisteiden indeksinumerot
for k = 1 : size(X, 2)
    text(X(1,k)+0.2, X(2,k)-0.1, num2str(k));
end;

% Listn klusterien keskipisteet
for k = 1 : lkmK
    pk = plot(kkpiste(k,1), kkpiste(k,2), vm{k});
    set(pk, 'MarkerSize', 14, 'LineWidth', 2);
    te1 = text(kkpiste(k,1)+0.1, kkpiste(k,2)+0.1, ['Keskipiste #' num2str(k)]);  
end;

% Kirjoitetaan klusterijako ruudulle
disp('*** c-means ryhmittelyn tulokset ***');
for k = 1 : lkmK
    ind = find(cl_ind == k);
    disp(['Ryhman #' num2str(k) ' datapisteiden indeksit:']);
    disp(ind);
end;

