%% DT_T4_d3.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #4
% Demo 3
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Hierarkkinen ryhmittely
%
% Tm on paperilaskarien tehtv H4 / 2.

%% Kokeilu:
% 
% - muokkaa rivien 63-65 mittaa "mitta"
% - muokkaa rivin 94 klusterimr "lkmK"
% - lis omaa dataa rivi 26-27 "X"

%% Datapisteet
%
% Data on esitetty kurssilla esitetyll tavalla:
%  muuttujat rivein ja havainnot sarakkeina. 
%  Matlab tulkitsee datamatriisin juuri toisinpin
%  ja siksi X tullaan transponoimaan muuttujaksi D Matlabin
%  ryhmittelyfunktiolle.

X = [0  1  2.5  3   3  5; 
    0   1  2.5  2   4  3];
D = X';  % Matlabin omia laskurutiineja varten matriisi "toisin pin"

%% Piirretn

figure(431); clf;
plot(X(1,:), X(2,:), 'x');
grid on;
title(['Datapisteet n = ' num2str(size(X,2))]);
axis equal;
aXlim = get(gca,'XLim');
aYlim = get(gca,'YLim');
aXlim = aXlim + (aXlim(2)-aXlim(1))*[-.1 .1];
aYlim = aYlim + (aYlim(2)-aYlim(1))*[-.1 .1];
axis([aXlim aYlim]);

for k = 1 : size(X, 2)
    text(X(1,k)+0.2, X(2,k)-0.1, num2str(k));
end;

% Seuraavaa tarvitaan ryppit eroteltaessa
vm = {'bo','kx','r+','c*','ms','gd','bv','g^','r<','c>','mp','kh','b+','g*','rs','cd','mo','kx','bs','gd','ro','cx','ms','kd'};

%% Hierarkkinen ryhmittely
%
% Tss siis Matlabin omille funktioille annetaan D == X';

% pdist = "pairwise distances". Lasketaan pisteiden vliset
%  etisyydet. Valitaan euklidinen etisyys.
Y   = pdist(D, 'euclidean');

% Ryhmien vlisen etisyyden mittaaminen.
%  Kts. luentokalvojen Luku 6, kalvo 32/55
%   - ryhmien keskipistevektorit == 'average'
%   - lyhin etisyys == 'single'
%   - pisin etisyys == 'complete'
mitta = 'single';
%mitta = 'complete';
%mitta = 'average';

% Lasketaan ryhmien yhdistminen halutulla mitalla
Z   = linkage(Y, mitta); 

% Piirretn ryhmittelypuu.
%  dendrogram(Z) piirt tietyn mrn oksia,
%  dendrogram(Z, 0) piirt koko puun.
figure(432); clf;
dendrogram(Z, 0);
title(['Ryhmittelypuu (ryhmien vlinen et.mitta:  "' mitta '")']);
xlabel('Datapisteiden indeksinumerot');
ylabel('Ryhmien etisyys yhdistmistilanteessa');
grid on;

% Komento 'dendrogram(Z, 0)' piirt koko puun, mutta ole varoivainen 
%  jos mukana paljon datapisteit (yli sata). Voit toki zoomata puuta.
% Komennolla '[H,T] = dendrogram(Z)' voidaan selvitt "katkaistuihin"
%  oksiin liittyvt lehdet, kts. 'doc dendrogram'.

%% Hierarkkisen ryhmittelyn klusterit
%
% Funktio 'cluster' palauttaa indeksijonon cl_ind, jossa
%  on datapisteiden mr indeksej i liittyen kuhunkin
%  ryhmn C_i, i = 1..lkmK, jossa lkmK ryhmien lukumr.
% Ensin mrtn lkmK, joka kertoo, mist kohtaa ryhmittelypuuta
%  puu katkaistaan, jotta saadaan lkmK ryhm.

% VOIT MUUTTAA lkmK
lkmK  = 3;               % mr klusterien lukumrn
cl_ind = cluster(Z, 'maxclust', lkmK); 

% Piirretn viiva puuhun -- l muuta!
if ((lkmK >= 1) & (lkmK <= size(X,2)))
    if (lkmK == size(X, 2))
        dummy = get(gca,'YLim');
        y3l = mean([Z(1,3) dummy2(1)]);
    elseif (lkmK == 1)
        dummy = get(gca,'YLim');
        y3l = mean([Z(end,3) dummy2(2)]);
    else
        y3l = mean(Z(end-lkmK+1:end-lkmK+2,3));
    end;
    dummy = get(gca,'XLim');
    
    figure(432);
    li1 = line([0.5 dummy(2)-0.5], [y3l y3l]);
    set(li1, 'LineStyle', '-.', 'LineWidth', 2, 'Color', [0 0 0]);
    text(0.4, y3l+0.01*(dummy(2)-dummy(1)), ...
        ['Klusterien lkm = ' num2str(lkmK)]);
end;


%% Piirretn hierarkkisen ryhmittelyn tulokset
%
% Piirretn klusterit eri vreill/merkeill

figure(433); clf;
for k = 1 : lkmK
    ind = find(cl_ind == k);
    plot(X(1,ind), X(2, ind), vm{k});
    hold on;
end;
grid on;
title(['Data jaettuna ' num2str(lkmK) ' ryhmaan (mitta: "' mitta  '")']);
axis equal; 
axis([aXlim aYlim]);

% Listn 'legend'
for k = 1 : lkmK
    legTitle{k} = ['Klusteri #' num2str(k)];
end;
legend(legTitle, 'Location', 'SouthEast');

% Listn datapisteiden indeksinumerot
for k = 1 : size(X, 2)
    text(X(1,k)+0.2, X(2,k)-0.1, num2str(k));
end;

% Kirjoitetaan klusterijako ruudulle
disp('*** Hierarkkisen ryhmittelyn tulokset ***');
for k = 1 : lkmK
    ind = find(cl_ind == k);
    disp(['Ryhman #' num2str(k) ' datapisteiden indeksit:']);
    disp(ind);
end;

