%% DT_T4_d4.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #4
% Demo 4
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Kasvokuvien klusterointi
%
% Ryhmitelln TK2-kierroksen kasvokuvia "automaagisesti"!

%% Tehtv:
% 
% - koodaa haluamasi ryhmittelyalgoritmi (muutamia rivej)
%    kohtaan "TOTEUTUS" rivilt 127 alkaen
% - tee erinisi valintoja rivilt 101 alkavassa lohkossa: 
%    valitse data, klusterien lkm, ryhmittelyalgoritmi
% - monia visualisointeja valmiina rivilt 157 alkaen:
%    ei pitisi tarvita tehd omia

%% Siivotaan tarpeen tullen

close all;   % sulje kaikki ikkunat
clear        % poistetaan kaikki muuttujat muistista
clc          % tyhjennet??n ruutukin

%% Ladataan muuttujat MAT-tiedostosta

load DT_T4.mat
% Sislt muuttujat PY XK K K2, joihin tutustuttu TK2-kierroksella.
%  PY  (2x92)        2D-projisoidut pisteet
%  XK (361x92)      keskiarvoistettu datamatriisi X
%  K  (19x19x1x92)  alkuperiset kasvokuvat, 92 kpl 19x19 pikseli
%  K2 (19x19x1x92)  2D-projektioista palautetut kasvokuvat

%% Piirretn alkuperinen kasvokuva-aineisto

myMontage(K, 'Alkuperiset kasvot', 441);

%% Kasvokuvien projektio xy-tasolle
%
% Tm PCA-projektio tehtiin Matlab-harjoitukset kierroksella TK 2.

figure(442); clf;
for k= 1 : size(PY,2)
    plot(PY(1,k), PY(2,k), 'bx');
    hold on;
    ti = text(PY(1,k), PY(2,k), num2str(k));
    set(ti,'Color',[0 0 1]);
end;
grid on;
title('Kasvokuvien projektio 2D:en (PCA-selittvyys 42%)');

%% Projektiopisteiden palautus kuviksi
%
% Kokonaisvaihtelusta tss 42%:
%  - nyttnevt jo kasvoilta
%  - ei kovin hyv tunnistamiseen?
%  - eroja eri henkiliden vlill

myMontage(K2, 'Kasvokuvat PCA1-PCA2-projektiossa', 443);

%% 2D-pisteiden ryhmittelyalgoritmit
%
% Ryhmittelymenetelmi:
%   - hierarkkinen ryhmittely
%     o funktioita: pdist, linkage, dendrogram, cluster
%     o pdist: etisyysmitta, mm. 'euclidean', 'cityblock',...
%     o linkage: ryhmien vlinen etisyys, mm. 'single', 'complete',...
%     o dendrogram: piirr ryhmittelypuu, koko puu: 'dendrogram(Z, 0)'
%     o cluster: pt lopuksi kuinka monta klusteria 'lkmK' haluat
%        tai anna ptt "paras" katkaisukohta
%   - dynaaminen ryhmittely == k-means == c-means
%     o funktio: kmeans
%     o etukteen ryhmien lukumr 'lkmK'
%     o kokeile ajaa useita kertoja: eri alkuarvoilla eri tulokset!
%
% KATSO KYTTOHJEITA joko tmn kierroksen demoista #2 ja #3
%  tai Matlabin helpeist 'help kmeans', 'doc kmeans'.
% 
% Kytss oleva data: PY (2D) ja XK (361D)
%
%  Kuinka ryhmittely onnistuu 2D-projektiodatalle (projisoitu
%   361D -> 2D kytten PCA:ta, jolloin 42% kokonaisvaihtelusta
%   ji jljelle)? Kytetn datana 'kmeans' tai 'pdist' -funktioon
%   dataa PY'.
%
%  Ent kuinka ryhmittely muuttuu, kun otetaan kyttn koko
%   data eli 361-ulotteinen XK? Kytetn datana 'kmeans' tai 
%   'pdist' -funktioon dataa XK'.
%
%  Voit mitata Matlabin kuluttamaa aikaa "tic, <koodisi>, toc"
%
%  HUOM! Kurssin notaatiossa XK:n ja PY:n sarakkeet havaintoja, kun
%   taas Matlabissa rivit ovat havaintoja. PY luetaan
%   koodin alussa mat-tiedostosta ja sen koko on (2x92) -
%   PY transponoidaan (hipsu) kokoon (92x2). Vastaavasti
%   XK luetaan mat-tiedostosta ja sen koko on (361x92) -
%   transponoidaan muotoon (92x361).

%% Tehdn kaikki valinnat tss lohkossa!!!
%
% Valitaan:
%  1. datasetti: joko 2D tai 361D muuttujaan D
%  2. ryhmien lkm muuttujaan lkmK
%  3. ryhmittelyalgoritmi: joko c-means tai hierarkinen

% 1. Data
%  Aktivoi jompi kumpi. Aloita ensin vaikkapa PY':st eli
%  projisoidusta datasta.
D  = PY';   % projisoitu 2D-data
%D  = XK';  % alkuperinen 361D-dta

% 2. Ryhmien lkm
%  Anna ryhmien lukumr:
%  - 'kmeans': erityisen olennainen, koska mrttv etukteen.
%  - hierarkinen: mist kohtaa puu katkaistaan (oksien lkm)
lkmK = 3;          % ryhmien lukumr kmeans.m / cluster.m varten

% 3. Ryhmittelyalgortmi
%  VALITSE kumman pmenetelmn koodaat:
%  - c-means: anna arvo 1
%  - hierarkinen: anna arvo 0
ryhm_algoritmi = 1;  % c-means
%ryhm_algoritmi = 0;  % hierarkinen

%% TOTEUTUS
%
% KOODAA TNNE JOMPIKUMPI RYHMITTELYALGORITMI 
%  SOPIVILLA PARAMETRIARVOILLA. 
%
% HUOM! Poista/kommentoi rivit 151 ja 155 tarvittaessa!
%
% Sisntuleva data D (Matlabille valmiiksi oikein transponoituna).
% Ulostuleva data: 92 indeksi, jotka viittaavat 
%  klusterien indeksinumeroihin. Lue nm pystyvektoriin
%  'cl_ind' joko komennosta 'kmeans' (dynaaminen) 
%  tai 'cluster' (hierarkkinen).

% ... koodaa tnne noin 1-5 rivi kyseist algoritmia:





% figure(444); clf;   % tnne esimerkiksi ryhmittelypuu hierarkkisessa 



% DUMMY!!! Poista alla oleva rivi, kun olet laskenut cl_ind:n
cl_ind = [ones(22,1); 2*ones(50,1); 3*ones(20,1)];  

% DUMMY!!! JOS kytt 'kmeans' tallenna toinen palautettu 
% arvo (matriisi) muuttujaan 'kkpiste' ja poista
kkpiste = [-300 500; 100 -200; 650 550];     

%% Valmis visualisointi I: Ryhmt 2D-projektiossa

% Seuraavaa tarvitaan ryppit eroteltaessa
vm = {'bo','kx','r+','c*','ms','gd','bv','g^','r<','c>','mp','kh','b+','g*','rs','cd','mo','kx','bs','gd','ro','cx','ms','kd'};

figure(442); clf;

legTit = cell(lkmK,1);
for j = 1 : lkmK
    ind       = find(cl_ind == j);
    plot(PY(1,ind), PY(2,ind), vm{j});
    hold on;
    legTit{j} = ['Ryhma #'  num2str(j)];
end;

grid on;
legend(legTit,'Location','SouthWest');
if ryhm_algoritmi
    % c-means:
    title(['Klusteroitu data: c-means']);
else
     % c-means:
    title(['Klusteroitu data: hierarkinen']);
end;
   

% JOS tehty 'kmeans' JA talletettu klusterien keskipisteet
%  funktiosta 'kmeans' muuttujaan 'kkpiste', VOIDAAN
%  halutessa piirt klusterien keskipisteet.
%
% if-lauseen ehdossa 0 = hierarkinen, 1 = k-means:
if ryhm_algoritmi
    % L PIIRR hierarkiselle ryhmittelylle!
    for j = 1 : lkmK
        pk = plot(kkpiste(j,1), kkpiste(j,2), vm{j});
        set(pk, 'MarkerSize', 14, 'LineWidth', 2);
        te1 = text(kkpiste(j,1)+0.1, kkpiste(j,2)+0.1, ['Keskipiste #' num2str(j)]);
    end;
end;

%% Valmis visualisointi II: Ryhmt alkuper?isin? kasvokuvina
%
% Kuvaikkunat No 1001 alkaen.

% Seuraavilla voidaan piirt kasvokuvaikkunat eri kohtiin
posW1 = [20 50 250 150];

for j = 1 : lkmK
    figN = 1000+j;

    ind  = find(cl_ind == j);
    
    myMontage(K(:,:,:,ind), ['Klusteri #' num2str(j)], figN);
    set(gcf, 'Position', posW1 + [50*j,0,0,0]);
end;

%% Valmis visualisointi III: Ryhmt projisoituina kasvokuvina
%
% Kuvaikkunat No 1101 alkaen.

% Seuraavilla voidaan piirt?? kasvokuvaikkunat eri kohtiin
posW2 = [20 250 250 150];

for j = 1 : lkmK
    figN = 1101+j;

    ind  = find(cl_ind == j);
    
    myMontage(K2(:,:,:,ind), ['Klusteri #' num2str(j)], figN);
    set(gcf, 'Position', posW2 + [50*j,0,0,0]);
end;

%% Pohdiskelu
%
% - Oliko 2D-projektiopisteiden ryhmittely 2D-tasossa j?rkev??
% - Oliko 2D-projektiopisteiden ryhmittely 361D-tasossa jrkev?
% - Kun ryhmitelty koko datalla XK, niin miksi
%    2D-projektion klusterit ovat "sekaisin"?
%
% - Mit eroja hiearkisen ryhmittelyn yhdistelykriteereill?
%    'single' (eli lhin) ja 'complete' (eli pisin et?isyys)
%

