function X = myK2X(K)
% MYK2X muuttaa kuvakokoelman K (uint8) datamatriisiksi X 
% (double) siten, ett kukin yksittinen kuva tulee X:n 
% sarakkeeksi. Kuva skannataan sarakkeittain Matlabin 
% indeksinnin mukaisesti.
%
%    X = myK2X(K)
% 
%    X         datamatriisi (rc x n)
%    K         kuvakokoelma muodossa (r x c x 1 x n),
%              katso "help montage"
%
% Esimerkki:
%    load 12345A;
%    X = myK2X(K);

% Jukka Parviainen, 2005-2008

if nargin == 0
    error('Liian vhn argumentteja. Katso "help myK2X"');
end;
if (length(size(K)) ~= 4)
    error('Kuvakokoelma K vrn muotoinen.  Katso "help myK2X"');
end;

r  = size(K,1);
c  = size(K,2);
n  = size(K,4);
d  = r*c;
X  = reshape(double(K(:)), d, n);
